// Projet Imagine++: kaleidoscope
// Auteur: Pascal Monasse

#include "util.h"
#include <iostream>

using namespace std;

// Q10
void miroirh(Img& img, Bloc b) {
    b.w /= 2;
    Img gauche = copie(img, b);
    translate(img, voisinh(b), -b.w, 0);
    colle(img, gauche, b.x+b.w, b.y);
}

// Q11
void miroirh(Img img) {
    const Bloc B = {0,0,img.width(),img.height()};
    for(int i=0; i<2; i++) {
        Bloc bInit = B;
        while(bInit.w > 1) {
            for(Bloc b=bInit; b<=B; b=voisinh(b))
                miroirh(img, b);
            presente_image(img);
            bInit.w /= 2;
        }
    }
}

// Q12
void miroirv(Img& img, Bloc b) {
    b.h /= 2;
    Img haut = copie(img, b);
    translate(img, voisinv(b), 0, -b.h);
    colle(img, haut, b.x, b.y+b.h);
}

// Q12
void miroirv(Img img) {
    const Bloc B = {0,0,img.width(),img.height()};
    for(int i=0; i<2; i++) {
        Bloc bInit = B;
        while(bInit.h > 1) {
            for(Bloc b=bInit; b<=B; b=voisinv(b))
                miroirv(img, b);
            presente_image(img);
            bInit.h /= 2;
        }
    }
}

// Q13
void miroirhv(Img img) {
    const Bloc B = {0,0,img.width(),img.height()};
    for(int i=0; i<2; i++) {
        Bloc bInit=B;
        while(bInit.w > 1) {
            for(Bloc by=bInit; by<=B; by=voisinv(by))
                for(Bloc bx=by; bx<=B; bx=voisinh(bx))
                    miroirh(img, bx);
            presente_image(img);
            bInit.w /= 2;

            for(Bloc by=bInit; by<=B; by=voisinv(by))
                for(Bloc bx=by; bx<=B; bx=voisinh(bx))
                    miroirv(img, bx);
            presente_image(img);
            bInit.h /= 2;
        }
    }
}

// Q14
void tourne(Img& in, Bloc b) {
    b.w /= 2;
    b.h /= 2;
    Bloc bNW=b, bNE=voisinh(bNW), bSW=voisinv(bNW), bSE=voisinh(bSW);
    Img NW = copie(in, bNW);
    translate(in, bNE, -b.w,0);
    translate(in, bSE, 0, -b.w);
    translate(in, bSW, b.w, 0);
    colle(in, NW, bSW.x, bSW.y);
}

// Q15
void tourne(Img img) {
    const Bloc B = {0,0,img.width(),img.height()};
    for(int i=0; i<4; i++) {
        Bloc bInit = B;
        while(bInit.w > 1) {
            for(Bloc by=bInit; by<=B; by=voisinv(by))
                for(Bloc bx=by; bx<=B; bx=voisinh(bx))
                    tourne(img, bx);
            presente_image(img);
            bInit.w /= 2;
            bInit.h /= 2;
        }
    }
}

int main() {
    Img img;
    if (!load(img,srcPath("lena.png"))) { // Stop si l'image n'est pas chargee
        cout << "Erreur: " << srcPath("lena.png") << " introuvable" << endl;
        return 0;
    }
    openWindow(img.width(), img.height());
    display(img); // Affichage de l'image
    click();

    cout << "Miroir horizontal" << endl; miroirh(img);  click();
    cout << "Miroir vertical"   << endl; miroirv(img);  click();
    cout << "Miroir mixte"      << endl; miroirhv(img); click();
    cout << "Rotation"           << endl; tourne(img);

    endGraphics();
    return 0;
}
